#include "main.h"
#include "path_a.h"

void path_a::make_path()
{
	grid_array->sqaure_info[start].colx=0.0;
	grid_array->sqaure_info[start].coly=1.0;
	grid_array->sqaure_info[start].colz=0.0;
	//colour end  grid white
	grid_array->sqaure_info[end].colx=1.0;
	grid_array->sqaure_info[end].coly=0.0;
	grid_array->sqaure_info[end].colz=0.0;	

	if (draw_a==1)
	{
	cycles_taken++; 
	for (int s=0; s<loops; s++)
	{
	int temp_grid_num;
	//loop 
	//loop through to get a open node
	
	
		
		temp_grid_num = check_open();
		
		grid_array->sqaure_info[temp_grid_num].is_open = 0;
		grid_array->sqaure_info[temp_grid_num].visited = 1;
		if (temp_grid_num == end)
			{
				calculate_path();
				//colour starting  grid white
				grid_array->sqaure_info[start].colx=0.0;
				grid_array->sqaure_info[start].coly=1.0;
				grid_array->sqaure_info[start].colz=0.0;
				//colour end  grid white
				grid_array->sqaure_info[end].colx=1.0;
				grid_array->sqaure_info[end].coly=0.0;
				grid_array->sqaure_info[end].colz=0.0;
				//construct path 
				
				cout<<"cycles_taken: "<<cycles_taken<<endl;
				
				return;
			}
			if (grid_array->sqaure_info[end].visited == 0)
			{
        	check_nieghbours(temp_grid_num);	
			}
	
	}
	//colour starting  grid white
	
	
	}
}


//CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN 
//CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN
int path_a::check_open()
{
	int grid_size= ( grid_array->stepsX + 1 )*( grid_array->stepsZ + 1 );
	int temp_grid_value = 10000000;	//a ridiculasly large value to check against later
	int temp_grid_num = -1;

	for (int i = 0; i<grid_size; i++)
	{
		if (grid_array->sqaure_info[i].is_open == 1 && grid_array->sqaure_info[i].f < temp_grid_value )
		{

			temp_grid_value = grid_array->sqaure_info[i].f;
			temp_grid_num   = i;
		}
	}
	return temp_grid_num;
}
//CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE
//CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE
void path_a::calculate_path()
{
	int counter=1;
	int grid_ref = end;
	while(grid_ref != -1)
	{
	grid_array->sqaure_info[grid_ref].colx=1.0;
	grid_array->sqaure_info[grid_ref].coly=1.0;
	grid_array->sqaure_info[grid_ref].colz=0.0;
	grid_ref = grid_array->sqaure_info[grid_ref].parent;
	counter++;
	}
	cout<<"total tiles covered on path: "<< counter << endl;
	is_path_drawable = 1;
	routes_taken = new CVector3[counter - 1];
	routes_length = counter--;
	grid_ref = end;
	int num = counter--;
	while(grid_ref != -1)
	{
		routes_taken[num].x = grid_array->sqaure_info[grid_ref].position.x;
		routes_taken[num].y = grid_array->sqaure_info[grid_ref].position.y;
		routes_taken[num].z = grid_array->sqaure_info[grid_ref].position.z;
		grid_ref = grid_array->sqaure_info[grid_ref].parent;
		num--;
	}
}

//SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID 
//SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID 
void path_a::set_grid(int grid_ref, int tp_grid)
{

if (grid_array->sqaure_info[tp_grid].visited == 0 && grid_array->sqaure_info[tp_grid].status  == 0   )
		{
		grid_array->sqaure_info[tp_grid].parent  = grid_ref; 
		grid_array->sqaure_info[tp_grid].is_open = 1;
		grid_array->sqaure_info[tp_grid].colx	 = 0.35;
		grid_array->sqaure_info[tp_grid].coly	 = 0.5;

		grid_array->sqaure_info[tp_grid].colz	 = 0.1;
		//calculating cost
		grid_array->sqaure_info[tp_grid].g = grid_array->sqaure_info[grid_ref].g + grid_array->stepSize;
		if(search_algorithm==1)grid_array->sqaure_info[tp_grid].g=0;

		grid_array->sqaure_info[tp_grid].h = heuristic( tp_grid);
		grid_array->sqaure_info[tp_grid].f = grid_array->sqaure_info[tp_grid].g + grid_array->sqaure_info[tp_grid].h;
		}
	

}


//CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS 
//CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS 
void path_a::check_nieghbours(int grid_ref)
{
//check if our grid ref is on da edge of the grid
								
								int	tp_grid;
	 							 
								 if (!(grid_array->sqaure_info[ grid_ref  ].position.x == 
								       grid_array->sqaure_info[ 0		  ].position.x)   )
										
									  { 
										tp_grid = grid_ref-1; 
										set_grid(  grid_ref,  tp_grid);
									  }

								 if (!(grid_array->sqaure_info[ grid_ref	].position.z == 
									   grid_array->sqaure_info[ 0			].position.z)	)
									 	
									  { tp_grid = grid_ref - (grid_array->stepsX+1);
										set_grid(  grid_ref,  tp_grid);
									  }

								 if (!(grid_array->sqaure_info[ grid_ref		 						      ].position.x == 
									   grid_array
									   ->sqaure_info[(grid_array->stepsX+1)*(grid_array->stepsZ+1)-1].position.x)	)
								
									  { tp_grid = grid_ref + 1;
										set_grid(  grid_ref,  tp_grid);
									  }

								 if (!(grid_array->sqaure_info[ grid_ref								     ].position.z == 
									   grid_array->sqaure_info[(grid_array->stepsX+1)*(grid_array->stepsZ+1)-1].position.z) )
													
									  { tp_grid = grid_ref + (grid_array->stepsX+1);
										set_grid(  grid_ref,  tp_grid);
									  }

}
//HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC 
//HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC
float path_a :: heuristic( int current_pos )
{

	//if (
	//manhattan manhattan manhattan
	// manhattan manhattan manhattan
	if (search_algorithm==3)
	{
			float distance;
	distance =  ( abs(grid_array->sqaure_info[current_pos].position.x - grid_array->sqaure_info[end].position.x) + 
				  abs(grid_array->sqaure_info[current_pos].position.z - grid_array->sqaure_info[end].position.z)	);
			return distance;
	}

	//dead straight line
	//dead straight line
	if (search_algorithm==4)
	{
	float distance;
	float distancex =   grid_array->sqaure_info[current_pos].position.x - grid_array->sqaure_info[end].position.x; 
	float distancez =   grid_array->sqaure_info[current_pos].position.z - grid_array->sqaure_info[end].position.z;
	if (distancex<0)distancex=-distancex;
	if (distancez<0)distancez=-distancez;
		
	distance = sqrt(distancex*distancex+distancez*distancez);

	//crossing the distance between the start and the goal and the current pos and the goal
	float dx1 = grid_array->sqaure_info[current_pos].position.x -	grid_array->sqaure_info[end].position.x;
	float dy1 = grid_array->sqaure_info[current_pos].position.z -	grid_array->sqaure_info[end].position.z;
	float dx2 = grid_array->sqaure_info[start].position.x -			grid_array->sqaure_info[end].position.x;
	float dy2 = grid_array->sqaure_info[start].position.z -			grid_array->sqaure_info[end].position.z;
	float cross = dx1*dy2 - dx2*dy1;
		if( cross<0 ) cross = -cross;
    distance += cross*0.01;//add the abs of the cross to our search
	return distance
		*4;
	}

return 0;
}
//SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH 
//SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH 
void path_a :: set_path(colision *set_grid_array, int set_start, int set_end)
{
	grid_array = set_grid_array;


	grid_array->sqaure_info[set_start].is_open =  1;
	grid_array->sqaure_info[set_start].parent  = -1;
	grid_array->sqaure_info[set_start].visited =  1;
	grid_array->sqaure_info[set_start].g	   =  0;
	end=set_end;
	is_path_drawable=0;
	tempEnd = end;
	draw_a=0;
}
	
void path_a :: draw_route()
{
	
	if (is_path_drawable == 1)
	{
		glPointSize(22);
		glDisable(GL_LIGHTING);
			//cout<<"route 1.x"<<routes_taken[1].z<<endl;
		glBegin(GL_LINES );
		for (int i =1; i<routes_length-1; i++)
		{
		
		//draw sqaure
		glColor3f(0.6,1.0,0.0);
		glVertex3f(	routes_taken[i].x	,	0.34f	,	routes_taken[i].z	);
		glColor3f(1.0,1.0,1.0);
		glVertex3f(	routes_taken[i+1].x	,	0.34f	,	routes_taken[i+1].z	);
		}
		glEnd();
		glEnable(GL_LIGHTING);
	}
}

void path_a::move_path(colision *ground2)
{
	int double_check=10;
	slow_down_end_temp=slow_down_end_temp+0.3;

if (keyIndex[GLUT_KEY_LEFT])
	{
	
	if (slow_down_end_temp>1)
		{
		if (!(grid_array->sqaure_info[ tempEnd  ].position.x == 
			  grid_array->sqaure_info[ 0		].position.x)   )
			{	
				if (grid_array->sqaure_info[ tempEnd -1 ].status==0)
						tempEnd  = tempEnd -1;
			}
		slow_down_end_temp	=0;
		}
	}

if (keyIndex[GLUT_KEY_RIGHT])
	{
	
	if (slow_down_end_temp>1)
		{
	if (!(grid_array->sqaure_info[ tempEnd		 						      ].position.x == 
		  grid_array->sqaure_info[(grid_array->stepsX+1)*(grid_array->stepsZ+1)-1].position.x)	)
		 {
			{	
			if (grid_array->sqaure_info[ tempEnd +1 ].status==0)
					tempEnd  = tempEnd +1;
			}
				 
		 }
		 slow_down_end_temp	=0;
		}
	
	}
	

if (keyIndex[GLUT_KEY_UP])
	{

	if (slow_down_end_temp>1)
		{
	if (!(grid_array->sqaure_info[ tempEnd	].position.z == 
		  grid_array->sqaure_info[ 0		].position.z)	)
		 {
			{	
			if (grid_array->sqaure_info[tempEnd - (grid_array->stepsX+1) ].status==0)
					tempEnd  = tempEnd - (grid_array->stepsX+1);
			}				 
		 }	
		 slow_down_end_temp	=0;
		}

	}
	
if (keyIndex[GLUT_KEY_DOWN])
	{

	if (slow_down_end_temp>1)
		{
	if (!(grid_array->sqaure_info[ tempEnd									     ].position.z == 
	      grid_array->sqaure_info[(grid_array->stepsX+1)*(grid_array->stepsZ+1)-1].position.z) )
		 {
			{	
			if (grid_array->sqaure_info[ tempEnd + (grid_array->stepsX+1)].status==0)
					 tempEnd = tempEnd + (grid_array->stepsX+1);
			}				 
		 }	
		 slow_down_end_temp	=0;
		}
}




if (keyIndex[2])
{	
//set end
	ground2->reset();
	end =tempEnd ;
	draw_a=0;
	is_path_drawable=0;	
}
if (keyIndex[1])
{	
//set start
ground2->reset();
start = tempEnd;
ground2->sqaure_info[tempEnd].is_open =  1;
ground2->sqaure_info[tempEnd].parent  = -1;
ground2->sqaure_info[tempEnd].visited =  1;
ground2->sqaure_info[tempEnd].g		  =  0;
cycles_taken =0;
routes_length =0;

is_path_drawable=0;
draw_a=1;
}

if (keyIndex[3])
{
//decrease search per-cycle

slow_down_for_search_key=slow_down_for_search_key +0.03;
loops = abs (slow_down_for_search_key)	;
if (slow_down_for_search_key>3000)slow_down_for_search_key=1;

	
}

if (keyIndex[4])
{
//increase search per-cycle
slow_down_for_search_key=slow_down_for_search_key - 0.005;
loops = abs (slow_down_for_search_key)	;
	if (slow_down_for_search_key<0)slow_down_for_search_key=1;

}
if (keyIndex[5])
{
	//Breadth first 
cout<<"Breadth first"<<endl;
//no costs
search_algorithm=1;
}
if (keyIndex[6])
{
	//Dijkstra
//
	cout<<"Dijkstra"<<endl;
	search_algorithm=2;
}
if (keyIndex[7])
{
	//Breadth first 
	cout<<"A* Manhattan"<<endl;
	search_algorithm=3;
}
if (keyIndex[8])
{
	//Breadth first 
	cout<<"A* Breaking Ties"<<endl;
	search_algorithm=4;

}


glDisable(GL_LIGHTING);
glPointSize(12);
	glBegin(GL_POINTS );
	
	//draw sqaure
		glColor3f(0.4,0.60,0.4);
		glVertex3f(	grid_array->sqaure_info[tempEnd].position.x	,1
				   ,grid_array->sqaure_info[tempEnd].position.z	);
	glEnd();
glEnable(GL_LIGHTING);
}

