#ifndef _CAMERA_H
#define _CAMERA_H

///////////////////////////////////////////////////////////////////////////
//								CLASSES									 //
//																		 //
///////////////////////////////////////////////////////////////////////////


class CCamera				//camera class
{
public:
		CVector3 m_vPosition;	//position of camera
		CVector3 m_vView;		//view vector
		CVector3 m_vUp;			//up axis (hopefully wont need to change
		CVector3 m_vStrafe;

	CCamera ();//constructor
	
	//positioning camera member function, takes position, view and up vectors
	void Position(float positionX, float positionY,  float positionZ,		
				  float viewX,	   float viewY,		 float viewZ,
				  float upX,	   float upY,		 float upZ);
	
	//moving camera forward or back depending on speed being (+) or (-)
	void move(float speed);

	// rotate the camera left or right round a give axis xyz
	void rotate (float theta, float x, float y, float z);

	// mouse view x and y are the mouse coardinates
	void mouseView (int x, int y);

	void straf(float speed);

	void update();

	void look();
};

#endif