//lighting function file
#include "main.h"

Clighting ::Clighting()
{
	LightPosition[0]=1; LightPosition[1]=3; LightPosition[2]=1; LightPosition[3]=1;
	ambience[0]=0.0f;	ambience[1]=0.0f;	ambience[2]=0.0f;	ambience[3]=1.0;
	diffuse[0]=1.5f; diffuse[1]=1.1f; diffuse[2]=0.1f; diffuse[3]=1.0;


}

void Clighting:: setup()
{
	glLightfv( GL_LIGHT0, GL_AMBIENT,  ambience );		// Set our ambience values (Default color without direct light)
	glLightfv( GL_LIGHT0, GL_DIFFUSE,  diffuse );		// Set our diffuse color (The light color)
	glLightfv( GL_LIGHT0, GL_POSITION, LightPosition );	// This Sets our light position


	glEnable(  GL_LIGHT0   );								// Turn this light on
	glEnable(  GL_LIGHTING );
	
}

void Clighting:: position()
{
	glLightfv( GL_LIGHT0, GL_POSITION, LightPosition );	
}

