#include "main.h"
#include "vec.h"
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//		NORMAL AND CROSS PRODUCTS
//

//cross product gets our normal vector
void CVector3::crossProduct(CVector3 vec1, CVector3 vec2)
{
	CVector3 surfaceNorm;

	// The X value for the vector is:  (V1.y * V2.z) - (V1.z * V2.y)													// Get the X value
	x = ((vec1.y * vec2.z) - (vec1.z * vec2.y));
														
	// The Y value for the vector is:  (V1.z * V2.x) - (V1.x * V2.z)
	y = ((vec1.z * vec2.x) - (vec1.x * vec2.z));
														
	// The Z value for the vector is:  (V1.x * V2.y) - (V1.y * V2.x)
	z = ((vec1.x * vec2.y) - (vec1.y * vec2.x));

	// Return the cross product
										 
}
//normaliseer NORM
void CVector3::norm(void)
{
	double Magnitude;							// This holds the magnitude			

	Magnitude = sqrt(x*x + y*y + z*z);					// Get the magnitude

	x /= (float)Magnitude;				// Divide the vector's X by the magnitude
	y /= (float)Magnitude;				// Divide the vector's Y by the magnitude
	z /= (float)Magnitude;				// Divide the vector's Z by the magnitude
	// Return the normal
}


