#include "main.h"
#include "colision.h"

void colision::grid(obj_model		*model_pointer, float accuracy)
{
// create a bounding box of all da  poly's
x=-0.001f;  y=-0.001f; z=-0.001f;
X= 0.001f;  Y= 0.001f; Z= 0.001f;


int j,k;//vertex counter
long vertex_index;	//index long varible
long total_faces=model_pointer->background_faces;//how many faces

for (j=0; j<total_faces; j++)					//loop through each face
	{
	for (k=0; k<3; k++)							//looping through each vertex of the face
		{
		vertex_index =	model_pointer->face_array[j*9+k] *3;//get our face vertex position
		
		//check our face against our bounding box;
		if(model_pointer->vertex_array[vertex_index]<x)
		x=model_pointer->vertex_array[vertex_index];
		else if(model_pointer->vertex_array[vertex_index]>X)
		X=model_pointer->vertex_array[vertex_index];

		if(model_pointer->vertex_array[vertex_index+1]<y)
		y=model_pointer->vertex_array[vertex_index+1];
		else if(model_pointer->vertex_array[vertex_index+1]>Y)
		Y=model_pointer->vertex_array[vertex_index+1];
		
		if(model_pointer->vertex_array[vertex_index+2]<z)
		z=model_pointer->vertex_array[vertex_index+2];
		else if(model_pointer->vertex_array[vertex_index+2]>Z)
		Z=model_pointer->vertex_array[vertex_index+2];
		}
	}
//DIVIDE UP THE BOUNDING BOX INTO A TWO DEE SQUARE
float absX, absZ;
if (x<0)				//working out the distance along the X of the bounding box
 absX=(x*-1)+X;
else  absX= x+X;

if (z<0)				//working out the distance along the Z of the bounding box
 absZ=(z*-1)+Z;
else  absZ= z+Z;
//calculating the sqaures needed along the X and Z axis
 stepsX=int(absX/accuracy)+1;
 stepsZ=int(absZ/accuracy)+1;

stepSize=accuracy;
cout<< "grid size::" << (stepsX+1)*(stepsZ+1)<<endl;

//Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid 
//Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid

//loop through to create grid dots
	int i,grid_number=0;
			
	
	//storing the data in a  normal array
	sqaure_info=new board [(stepsX+1)*(stepsZ+1)];
	//temp board varible
	board temp_board;
	

	for(j=0; j<=stepsZ;j++)
	{
		for(i=0; i<=stepsX;i++)
		{
				//store data
		temp_board.x_pos= x+(i*stepSize);
		temp_board.X_pos=(x+(i*stepSize))+stepSize;
		temp_board.z_pos= z+(j*stepSize);
		temp_board.Z_pos=(z+(j*stepSize))+stepSize;
		temp_board.status=0;
		//push in array
		sqaure_info[grid_number]=temp_board;
		grid_number++;
		}
    }
//POLY CHECKING, each poly needs to check itself against every sqaure on the grid
//POLY CHECKING, each poly needs to check itself against every sqaure on the grid

//loop throught every face
	for (j=0; j<total_faces; j++)
	{
	//	now make a bounding box for that face

	//	loop throught every sqaure on the grid

	//		check the bounding box against the grid

	}

}

void colision::display(void)
{
	//edges of our scene depicted by dots
	glDisable(GL_LIGHTING);
	glPointSize( 1.0 );
	glBegin( GL_POINTS );
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	x,	0.0f,	Z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	x,	0.0f,	z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	X,	0.0f,	Z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	X,	0.0f,	z);
	glEnd();
		
	//draw our grid
	
	//evaluate grid size
	long grid_size=(stepsZ+1)*(stepsX+1);
   
	glBegin( GL_QUADS );
	float rgb[3]={1.0f,1.0f,1.0f};
	for(int i=0; i<grid_size;i++)
	{
		if (sqaure_info[i].status==1)
		{	rgb[1]=0.0f;	rgb[2]=0.0f;	}
		
		//draw sqaure
		glColor3fv(rgb);
		glVertex3f(	sqaure_info[i].X_pos	,	-1.0f	,	sqaure_info[i].z_pos	);glColor3fv(rgb);
		glVertex3f(	sqaure_info[i].x_pos	,	-1.0f	,	sqaure_info[i].z_pos	);glColor3fv(rgb);
		glVertex3f(	sqaure_info[i].x_pos	,	-1.0f	,	sqaure_info[i].Z_pos	);glColor3fv(rgb);
		glVertex3f(	sqaure_info[i].X_pos	,	-1.0f	,	sqaure_info[i].Z_pos	);
	}
	glEnd();
	glEnable(GL_LIGHTING);
}


