#include "main.h"


//global varibles
CCamera	g_Camera;
long Frame_Counter=1;
float t=0;

// Enables "multi-pressed" key combinations by using keyIndex as a key map
char keyIndex[256];
Ctextures teapot;
obj_model hand;
objLoader character;
Ctextures skin;
Clighting pointLight;
display view;
GLuint tex;
colision ground;

void init(void)
{		

	//load and create texture
	character.ImportObj(&hand,"background.obj");
	ground.grid(&hand, 0.25);
	skin.loader("file.tga");
	skin.createTexture(tex);
		
	teapot.material();
	
	pointLight.setup();
	pointLight.position();
	
	glutSetCursor(GLUT_CURSOR_NONE);
	
	g_Camera.setupDisplay();
	g_Camera.Position(0, 0.5f, 6,   0, 0.5f, 0,   0, 1, 0);


}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
		
	g_Camera.look();
	glPushMatrix();
		//view model
		view.showAll(&hand);
		ground.display();
	glPopMatrix();
	glutSwapBuffers();
	
	//these must be placed at the end
	pointLight.position();
	g_Camera.update();
}


void keyboard(int key, int x, int y)
{
keyIndex[(char)key]=1;
	

}
void keyUp(int key, int x, int y)
{
keyIndex[key]=0;
}


void mouseMotion(int x, int y)
{
	g_Camera.mouseView(x,y);
}

void mouse(int button, int state, int x, int y)
{
	
}

void idle()
{
	g_Camera.update();
	

}


void main(int argc,char *argv[])
{
	glutInit(&argc,argv); 
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
	glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);	
	glutInitWindowPosition(120,120);
	glutCreateWindow("camera class's ");
	init();  
	glutSpecialFunc(keyboard);
	glutSpecialUpFunc(keyUp);
	glutMouseFunc(mouse);
	glutMotionFunc(mouseMotion);
	glutPassiveMotionFunc(mouseMotion);
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	glutMainLoop();
	
}
