#ifndef _MAIN_H
#define _MAIN_H			//define main.h

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <fstream>
#include <string>		//strings i luv them
#include <GL/glut.h>	//main libraries
using namespace std;


#include "polyFace.h"
#include "vec.h"
#include "camera.h"
#include "textureClass.h"
#include "lighting.h"

#include "objLoader.h"
#include "colision.h"
#include "display_as_animation.h"
#include "path_a.h"



#define movement 0.03f


// some global defines
#define SCREEN_WIDTH	800								// We want our screen width 800 pixels
#define SCREEN_HEIGHT	800								// We want our screen height 600 pixels

///////////////////////////////////////////////////////////////////////////
//			    GLOBAL VARIBLES				//
//								       //					////////////////////////////////////////////////////////////////////////

// Extern our global variables so other source files can use them
extern CCamera	g_Camera;		// This will be our global camera data
extern long Frame_Counter;		//this will keep our frame number
extern float t;					//percent of frame to frame interperlation
extern int cycles_taken;		//this is the cycles taken in total for path finding
extern char keyIndex[256];		//key checker for our functions

//multikeypressing with our global varibles

//end if defined
#endif