#include "main.h"
#include "path_a.h"

void path_a::make_path(colision *grid_array)
{
	cycles_taken++; 
	{
	int temp_grid_num;
	//loop 
	//loop through to get a open node
	
	
		
		temp_grid_num = check_open(grid_array);
		
		grid_array->sqaure_info[temp_grid_num].is_open = 0;
		grid_array->sqaure_info[temp_grid_num].visited = 1;
		if (temp_grid_num == end)
			{
				calculate_path(grid_array);
				//colour starting  grid white
				grid_array->sqaure_info[start].colx=1.0;
				grid_array->sqaure_info[start].coly=1.0;
				grid_array->sqaure_info[start].colz=1.0;
				//colour end  grid white
				grid_array->sqaure_info[end].colx=1.0;
				grid_array->sqaure_info[end].coly=0.0;
				grid_array->sqaure_info[end].colz=0.0;
				//construct path 
				
				cout<<"cycles_taken: "<<cycles_taken<<endl;
				
				return;
			}
			if (grid_array->sqaure_info[end].visited == 0)
			{
        	check_nieghbours(grid_array,  temp_grid_num);	
			}
	
	}
	//colour starting  grid white
	grid_array->sqaure_info[start].colx=1.0;
	grid_array->sqaure_info[start].coly=1.0;
	grid_array->sqaure_info[start].colz=1.0;
	//colour end  grid white
	grid_array->sqaure_info[end].colx=1.0;
	grid_array->sqaure_info[end].coly=0.0;
	grid_array->sqaure_info[end].colz=0.0;	
	

}


//CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN 
//CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN CHECK OPEN
int path_a::check_open(colision *grid_array)
{
	int grid_size= ( grid_array->stepsX + 1 )*( grid_array->stepsZ + 1 );
	int temp_grid_value = 10000000;	//a ridiculasly large value to check against later
	int temp_grid_num = -1;

	for (int i = 0; i<grid_size; i++)
	{
		if (grid_array->sqaure_info[i].is_open == 1 && grid_array->sqaure_info[i].f < temp_grid_value )
		{

			temp_grid_value = grid_array->sqaure_info[i].f;
			temp_grid_num   = i;
		}
	}
	return temp_grid_num;
}
//CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE
//CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE PATH CALCULATE
void path_a::calculate_path(colision *grid_array )
{
	int grid_ref = end;
	while(grid_ref != -1)
	{
	grid_array->sqaure_info[grid_ref].colx=0.75;
	grid_array->sqaure_info[grid_ref].coly=1.0;
	grid_array->sqaure_info[grid_ref].colz=0.0;
	grid_ref = grid_array->sqaure_info[grid_ref].parent;
	}
}

//SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID 
//SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID SET GRID 
void path_a::set_grid(colision *grid_array, int grid_ref, int tp_grid)
{

if (grid_array->sqaure_info[tp_grid].visited == 0 &&
	grid_array->sqaure_info[tp_grid].status  == 0   )
		{
		grid_array->sqaure_info[tp_grid].parent  = grid_ref; 
		grid_array->sqaure_info[tp_grid].is_open = 1;
		grid_array->sqaure_info[tp_grid].colx	 = 0.0;
		//calculating cost
		grid_array->sqaure_info[tp_grid].g = grid_array->sqaure_info[grid_ref].g + grid_array->stepSize;
		grid_array->sqaure_info[tp_grid].h = heuristic(grid_array, tp_grid);


		grid_array->sqaure_info[tp_grid].f = grid_array->sqaure_info[tp_grid].h;
		}
	

}

//CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS 
//CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS CHECK NIEGHBOURS 
void path_a::check_nieghbours(colision *grid_array, int grid_ref)
{
//check if our grid ref is on da edge of the grid
								
								int	tp_grid;
	 							 
								 if (!(grid_array->sqaure_info[ grid_ref  ].position.x == 
								       grid_array->sqaure_info[ 0		  ].position.x)   )
										
									  { tp_grid = grid_ref-1; 
										set_grid(grid_array,  grid_ref,  tp_grid);
									  }

								 if (!(grid_array->sqaure_info[ grid_ref	].position.z == 
									   grid_array->sqaure_info[ 0			].position.z)	)
									 	
									  { tp_grid = grid_ref - (grid_array->stepsX+1);
										set_grid(grid_array,  grid_ref,  tp_grid);
									  }
								 if (!(grid_array->sqaure_info[ grid_ref		 						      ].position.x == 
									   grid_array->sqaure_info[(grid_array->stepsX+1)*(grid_array->stepsZ+1)-1].position.x)	)
								
									  { tp_grid = grid_ref + 1;
										set_grid(grid_array,  grid_ref,  tp_grid);
									  }

								 if (!(grid_array->sqaure_info[ grid_ref								     ].position.z == 
									   grid_array->sqaure_info[(grid_array->stepsX+1)*(grid_array->stepsZ+1)-1].position.z) )
													
									  { tp_grid = grid_ref + (grid_array->stepsX+1);
										set_grid(grid_array,  grid_ref,  tp_grid);
									  }

}
//HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC 
//HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC HEURISTIC
float path_a :: heuristic(colision *grid_array, int current_pos )
{
	//dead straight line
	float distance;
	float distancex =   grid_array->sqaure_info[current_pos].position.x - grid_array->sqaure_info[end].position.x; 
	float distancez =   grid_array->sqaure_info[current_pos].position.z - grid_array->sqaure_info[end].position.z;
	if (distancex<0)distancex=-distancex;
	if (distancez<0)distancez=-distancez;
		
	distance = sqrt(distancex*distancex+distancez*distancez);

	//crossing the distance between the start and the goal and the current pos and the goal
	float dx1 = grid_array->sqaure_info[current_pos].position.x -	grid_array->sqaure_info[end].position.x;
	float dy1 = grid_array->sqaure_info[current_pos].position.z -	grid_array->sqaure_info[end].position.z;
	float dx2 = grid_array->sqaure_info[start].position.x -			grid_array->sqaure_info[end].position.x;
	float dy2 = grid_array->sqaure_info[start].position.z -			grid_array->sqaure_info[end].position.z;
	float cross = dx1*dy2 - dx2*dy1;
		if( cross<0 ) cross = -cross;
    distance += cross*0.1;//add the abs of the cross to our search


	return distance;
}
//SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH 
//SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH SET PATH 
void path_a :: set_path(colision *grid_array, int set_start, int set_end)
{
	grid_array->sqaure_info[set_start].is_open =  1;
	grid_array->sqaure_info[set_start].parent  = -1;
	grid_array->sqaure_info[set_start].visited =  1;
	grid_array->sqaure_info[set_start].g	   =  0;
	end=set_end;
}
	

