#include "main.h"


//global varibles
CCamera	g_Camera;
long Frame_Counter=1;
float t=0;

// Enables "multi-pressed" key combinations by using keyIndex as a key map
char keyIndex[256];
Ctextures teapot;

Ctextures bitmap_vectors;
Clighting pointLight;
int num=0;
GLuint tex;
flow_grid			flow;
particle_system		crowd;
	//get our polygon size

	float quadX;
	float quadx;

	float quadZ;
	float quadz;


void init(void)
{		
	float y=1;
	float y2=12;
	float steppy= 12;
	float temp;
	temp = 1/(y- y2);
	cout<<"push: "<<temp<<endl;
	//load and create texture
	bitmap_vectors.loader("32_sample4.tga");
	bitmap_vectors.createTexture(tex);
	glutSetCursor(GLUT_CURSOR_NONE);
	g_Camera.setupDisplay();
	g_Camera.Position(0, 0.5f, 6,   0, 0.5f, 0,   0, 1, 0);
	quadX =  ((float)bitmap_vectors.get_sizeX())/10;
	quadx =   quadX*-1;
	quadZ =  ((float)bitmap_vectors.get_sizeY())/10;
	quadz =   quadZ*-1;

	flow.int_grid( ((float)bitmap_vectors.get_sizeX()), ((float)bitmap_vectors.get_sizeY()), bitmap_vectors.get_data());
	

}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
		
	g_Camera.look();
	glPushMatrix();
	glBindTexture(GL_TEXTURE_2D, 0);	
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
	
	glTexCoord2f(0.0f, 0.0f);glVertex3f(quadx,0,quadz);
	glTexCoord2f(1.0f, 0.0f);glVertex3f(quadX,0,quadz);
	glTexCoord2f(1.0f, 1.0f);glVertex3f(quadX,0,quadZ);
	glTexCoord2f(0.0f, 1.0f);glVertex3f(quadx,0,quadZ);

	glEnd();
	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
	flow.draw_vec();
	if (num>1023)num=0;
	crowd.caculate(num++, 100, &flow);
	crowd.render();

	glutSwapBuffers();
	
	//these must be placed at the end
	g_Camera.update();
}


void keyboard(int key, int x, int y)
{
keyIndex[(char)key]=1;
	

}
void keyUp(int key, int x, int y)
{
keyIndex[key]=0;
}


void mouseMotion(int x, int y)
{
	g_Camera.mouseView(x,y);
}

void mouse(int button, int state, int x, int y)
{
	
}

void idle()
{
	g_Camera.update();
	

}


void main(int argc,char *argv[])
{
	glutInit(&argc,argv); 
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
	glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);	
	glutInitWindowPosition(120,120);
	glutCreateWindow("camera class's ");
	init();  
	glutSpecialFunc(keyboard);
	glutSpecialUpFunc(keyUp);
	glutMouseFunc(mouse);
	glutMotionFunc(mouseMotion);
	glutPassiveMotionFunc(mouseMotion);
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	glutMainLoop();
}
