#pragma once

#include "main.h"
//vehicle model
class vehicle
{
public:
	//ATTRIBUTES 
	float mass;
	CVector3 velocity;	//velocity 
	CVector3 position;	//particle position
	CVector3 pushzdfg;		//a push vector for colision
	float Max_Force;	//max power plant
	float Max_Speed;	
	
		//ORIENTATION AXIS'S OF PARTICLES
		CVector3 orientationX,
				 orientationY, 
				 orientationZ; 
	
	//FLOW GRID REFERENCE
	int grid_ref;
	bool waiting_for_space;
	
};


class particle_system
{
public:

//list of particles


vector<vehicle>	particle_list;
int frame_number;

//FUNCTIONS
//applie forces
void caculate(int flow_grid_start, int total_frames,  flow_grid *grid_pointer);
//display the particles
void render();
//
};
