#include "main.h"


//global varibles
CCamera	g_Camera;

// Enables "multi-pressed" key combinations by using keyIndex as a key map
char keyIndex[256];
Ctextures teapot;
Clighting pointLight;
GLuint tex;
float i=0;

void init(void)
{		
	//load and create texture
	teapot.loader("file.tga");
	teapot.createTexture(tex);
	


	glShadeModel (GL_SMOOTH);
	glutSetCursor(GLUT_CURSOR_NONE);
	
	pointLight.setup;
	g_Camera.setupDisplay();
	g_Camera.Position(0, 0.5f, 6,   0, 0.5f, 0,   0, 1, 0);
}

void display(void)
{
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
	glBindTexture(GL_TEXTURE_2D,tex);
	pointLight.position();
	g_Camera.look();
		glPushMatrix();
		glutSolidTeapot(2.5);
		glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	glutSwapBuffers();
	g_Camera.update();
}


void keyboard(int key, int x, int y)
{
keyIndex[(char)key]=1;
	

}
void keyUp(int key, int x, int y)
{
keyIndex[key]=0;
}


void mouseMotion(int x, int y)
{
	g_Camera.mouseView(x,y);
}

void mouse(int button, int state, int x, int y)
{
	
}

void idle()
{
	g_Camera.update();
}


void main(int argc,char *argv[])
{
	glutInit(&argc,argv); 
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
	glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);	
	glutInitWindowPosition(120,120);
	glutCreateWindow("camera class's ");
	init();  
	glutSpecialFunc(keyboard);
	glutSpecialUpFunc(keyUp);
	glutMouseFunc(mouse);
	glutMotionFunc(mouseMotion);
	glutPassiveMotionFunc(mouseMotion);
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	glutMainLoop();
}
