//texture class TGA only at present
#define TGA_RGB		 2		// normal RGB (really BGR) file
#define TGA_A		 3		// ALPHA file
#define TGA_RLE		10		// Run-Length Encoded (RLE)

#ifndef TEXTURECLASS_H
#define TEXTURECLASS_H
#include <stdio.h>
#include <stdlib.h>


class Ctextures
{
public:
	
	
	//functions RETURNing PRIVATE DATA
	inline int				get_channels(void){return channels;}
	inline short int		get_sizeX(void){ return sizeX;}
	inline short int		get_sizeY(void){ return sizeY;}
	inline unsigned char*	get_data(void){ return data;}	
	
	//functions RETURNS GL_RGB or GL_RBA
	unsigned short			get_GL_channels(void);
	
	//constructor
	Ctextures();
	void loader (char* filename);
	//create a opengl texture
	void createTexture(GLuint textureName);
	//creates a material
	void material();
		
	
private:
	//image varibles
	int channels;
	short int sizeX;
	short int sizeY;
	unsigned char *data;

	//material varibles
	GLfloat	mat_specular[4];
	GLfloat	mat_shininess[1];
};

#endif