#include "main.h"
#include "colision.h"

void colision::grid(obj_model		*model_pointer, float accuracy)
{
// create a bounding box of all da  poly's
x=-0.001f;  y=-0.001f; z=-0.001f;
X= 0.001f;  Y= 0.001f; Z= 0.001f;


int j,k;//vertex counter
long vertex_index;	//index long varible
long total_faces=model_pointer->background_faces;//how many faces

for (j=0; j<total_faces; j++)					//loop through each face
	{
	for (k=0; k<3; k++)							//looping through each vertex of the face
		{
		vertex_index =	model_pointer->face_array[j*9+k] *3;//get our face vertex position
		
		//check our face against our bounding box;
		if(model_pointer->vertex_array[vertex_index]<x)
		x=model_pointer->vertex_array[vertex_index];
		else if(model_pointer->vertex_array[vertex_index]>X)
		X=model_pointer->vertex_array[vertex_index];

		if(model_pointer->vertex_array[vertex_index+1]<y)
		y=model_pointer->vertex_array[vertex_index+1];
		else if(model_pointer->vertex_array[vertex_index+1]>Y)
		Y=model_pointer->vertex_array[vertex_index+1];
		
		if(model_pointer->vertex_array[vertex_index+2]<z)
		z=model_pointer->vertex_array[vertex_index+2];
		else if(model_pointer->vertex_array[vertex_index+2]>Z)
		Z=model_pointer->vertex_array[vertex_index+2];
		}
	}
//DIVIDE UP THE BOUNDING BOX INTO A TWO DEE SQUARE
float absX, absZ;
if (x<0)				//working out the distance along the X of the bounding box
 absX=(x*-1)+X;
else  absX= x+X;

if (z<0)				//working out the distance along the Z of the bounding box
 absZ=(z*-1)+Z;
else  absZ= z+Z;
//calculating the sqaures needed along the X and Z axis
 stepsX=int(absX/accuracy)+1;
 stepsZ=int(absZ/accuracy)+1;

//creating array of our sqaures
refx	= new float[stepsX*stepsZ];
refz	= new float[stepsX*stepsZ];
stepSize=accuracy;
int i = 0;
//positioning each sqaure via a loopy
for ( j=0; j<stepsZ; j++)
{
refz[i]=z+(j*accuracy)+(accuracy/2);

	for (k=0; k<stepsX; k++)
	{
	refz[i]=x+(k*accuracy)+(accuracy/2);
	}
}
cout << "refz: "<<refz[3]<<"refx: "<<refx[0]<<endl;

}

void colision::display(void)
{
	//edges of our scene depicted by dots
	glDisable(GL_LIGHTING);
	glPointSize( 1.0 );
	glBegin( GL_POINTS );
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	x,	0.0f,	Z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	x,	0.0f,	z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	X,	0.0f,	Z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	X,	0.0f,	z);
	glEnd();
	glEnable(GL_LIGHTING);

	//loop through to create grid dots
	int j,i,grid_number;
	grid_number=stepsX*stepsZ;

	
	glDisable(GL_LIGHTING);
	glPointSize( 1.0 );
	glBegin( GL_POINTS );

	for(j=0; j<=stepsZ;j++)
	{
		for(i=0; i<=stepsX;i++)
		{
		glColor3f(0.9f,0.6f,0.2f);
		glVertex3f(	(x+(i*stepSize))+stepSize/2	,	0.0f	,	(z+(j*stepSize))+stepSize/2	);
		
		}
	}
	glEnd();
	glEnable(GL_LIGHTING);

}