#pragma once
#include "main.h"

class list_node
{
	public:
	int grid_num;	
	bool  status;	//blocked?
	float g;		//from this node to start node
	float h;		//heuristic from this node to end
	float f;		//g+h
	int parent;		//parent node to this one, if one NULL (-1)
	
//contructors
list_node()
{grid_num = 0; status = 0; g = 0; h = 0; f = 0; parent = 0;}

list_node(int grid_number, bool blocked, float g_distance, float h_distance, float f_distance, int parent_node)
{grid_num = grid_number; status = blocked; g = g_distance; h = h_distance; f = f_distance; parent = parent_node;}	

//operator overload
list_node operator= (list_node v)
{return list_node (grid_num = v.grid_num, status = v.status, g = v.g, h = v.h, f = v.f, parent = v.parent);}
};

class colision;
class path_a
{
public:
int start;
int end;

void make_path(colision *grid_array);
//check for node in grid 
int check_open(colision *grid_array); 
//check nieghbours and update them
void check_nieghbours(colision *grid_array, int grid_ref);

//for each of the nodes that are not blocked set them up
void set_grid(colision *grid_array, int grid_ref, int tp_grid);
//calculate path
void calculate_path(colision *grid_array);
//set a path
void set_path(colision *grid_array, int set_start, int set_end);
//heuristic
float heuristic(colision *grid_array, int current_pos);


};
