#include "main.h"
#include "colision.h"

void colision::grid(obj_model		*model_pointer, float accuracy)
{
// create a bounding box of all da  poly's
x=-0.001f;  y=-0.001f; z=-0.001f;
X= 0.001f;  Y= 0.001f; Z= 0.001f;


int j,k;//vertex counter
long vertex_index;	//index long varible
long total_faces=model_pointer->background_faces;//how many faces

for (j=0; j<total_faces; j++)					//loop through each face
	{
	for (k=0; k<3; k++)							//looping through each vertex of the face
		{
		vertex_index =	model_pointer->face_array[j*9+k] *3;//get our face vertex position
		
		//check our face against our bounding box;
		if(model_pointer->vertex_array[vertex_index]<x)
		x=model_pointer->vertex_array[vertex_index];
		else if(model_pointer->vertex_array[vertex_index]>X)
		X=model_pointer->vertex_array[vertex_index];

		if(model_pointer->vertex_array[vertex_index+1]<y)
		y=model_pointer->vertex_array[vertex_index+1];
		else if(model_pointer->vertex_array[vertex_index+1]>Y)
		Y=model_pointer->vertex_array[vertex_index+1];
		
		if(model_pointer->vertex_array[vertex_index+2]<z)
		z=model_pointer->vertex_array[vertex_index+2];
		else if(model_pointer->vertex_array[vertex_index+2]>Z)
		Z=model_pointer->vertex_array[vertex_index+2];
		}
	}
//DIVIDE UP THE BOUNDING BOX INTO A TWO DEE SQUARE
float absX, absZ;
if (x<0)				//working out the distance along the X of the bounding box
 absX=(x*-1)+X;
else  absX= x+X;

if (z<0)				//working out the distance along the Z of the bounding box
 absZ=(z*-1)+Z;
else  absZ= z+Z;
//calculating the sqaures needed along the X and Z axis
 stepsX=int(absX/accuracy)+1;
 stepsZ=int(absZ/accuracy)+1;

stepSize=accuracy;
cout<< "grid size::" << (stepsX+1)*(stepsZ+1)<<endl;

//Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid 
//Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid Save Grid

//loop through to create grid dots
	int i,grid_number=0;
			
	
	//storing the data in a  normal array
	sqaure_info=new flow_grid [(stepsX+1)*(stepsZ+1)];
	//temp board varible
	flow_grid temp_board;
	

	for(j=0; j<=stepsZ;j++)
	{
		for(i=0; i<=stepsX;i++)
		{
				//store data
//		temp_board.x_pos= x+(i*stepSize);
//		temp_board.X_pos=(x+(i*stepSize))+stepSize;
//		temp_board.z_pos= z+(j*stepSize);
//		temp_board.Z_pos=(z+(j*stepSize))+stepSize;

		//push in array
		sqaure_info[grid_number]=temp_board;
		grid_number++;
		//cout <<"grid pos's"<<"	x="<<temp_board.x_pos<<"	X="<<temp_board.X_pos<<"	z="<<temp_board.z_pos<<"	Z="<<temp_board.Z_pos<<endl;
		}
    }
//POLY CHECKING, each poly needs to check itself against every sqaure on the grid
//POLY CHECKING, each poly needs to check itself against every sqaure on the grid

//varible for max dimensions
float x_p, X_p, z_p, Z_p;
float x_g, X_g, z_g, Z_g;

//loop throught every face
	for (j=0; j<total_faces; j++)
	{
	//	now make a bounding box for that face
		
		//1st vertex equals min and max(which is the state so fast)
		vertex_index =	model_pointer->face_array[j*9]*3;
		//cout<<"x= "<<model_pointer->vertex_array[vertex_index]<<" z="<<model_pointer->vertex_array[vertex_index+2]<<endl;
		x_p=model_pointer->vertex_array[vertex_index];
		X_p=model_pointer->vertex_array[vertex_index];
		z_p=model_pointer->vertex_array[vertex_index+2];
		Z_p=model_pointer->vertex_array[vertex_index+2];
		//check the 2nd vertex against the high low values
		vertex_index =	model_pointer->face_array[j*9+1]*3;
		//cout<<"x= "<<model_pointer->vertex_array[vertex_index]<<" z="<<model_pointer->vertex_array[vertex_index+2]<<endl;
		if ( model_pointer->vertex_array[vertex_index]   < x_p ) x_p=model_pointer->vertex_array[vertex_index];
		if ( model_pointer->vertex_array[vertex_index]	 > X_p ) X_p=model_pointer->vertex_array[vertex_index];
		if ( model_pointer->vertex_array[vertex_index+2] < z_p ) z_p=model_pointer->vertex_array[vertex_index+2];
		if ( model_pointer->vertex_array[vertex_index+2] > Z_p ) Z_p=model_pointer->vertex_array[vertex_index+2];

		//check 3rd vertex against the high and low values
		vertex_index =	model_pointer->face_array[j*9+2]*3;
		//cout<<"x= "<<model_pointer->vertex_array[vertex_index]<<" z="<<model_pointer->vertex_array[vertex_index+2]<<endl;
		if ( model_pointer->vertex_array[vertex_index]   < x_p ) x_p=model_pointer->vertex_array[vertex_index];
		if ( model_pointer->vertex_array[vertex_index]	 > X_p ) X_p=model_pointer->vertex_array[vertex_index];
		if ( model_pointer->vertex_array[vertex_index+2] < z_p ) z_p=model_pointer->vertex_array[vertex_index+2];
		if ( model_pointer->vertex_array[vertex_index+2] > Z_p ) Z_p=model_pointer->vertex_array[vertex_index+2];

		//cout<< "poly:" <<j<<" "<<"x_p:"<<x_p<<" "<<"X_p:"<<X_p<<" "<<"z_p:"<<z_p<<" "<<"Z_p:"<<Z_p<<" "<<endl;


		
		
	//	loop throught every sqaure on the grid
	
	

	}

}


void colision::display(void)
{
	//edges of our scene depicted by dots
	//glDisable(GL_LIGHTING);
	glPointSize( 11.0 );
	glBegin( GL_POINTS );
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	x,	0.0f,	Z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	x,	0.0f,	z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	X,	0.0f,	Z);
	glColor3f(1.0f,1.0f,1.0f);
	glVertex3f(	X,	0.0f,	z);
	glEnd();
		
	//draw our grid
	
	//evaluate grid size
	long grid_size=(stepsZ+1)*(stepsX+1);
   
	glBegin( GL_QUADS );
	float rgb[3]={1.0f,1.0f,1.0f};
	for(int i=0; i<grid_size;i++)
	{
		
		//cout<<"display_status: "<<sqaure_info[i].status<<endl;
		//if (sqaure_info[i].status==1)
		//{	rgb[0]=1.0f;rgb[1]=0.0f;rgb[2]=0.0f;	}
		
		
		{	rgb[0]=1.0f;rgb[1]=1.0f;rgb[2]=1.0f;	//}
		
		
		//draw sqaure
		glColor3fv(rgb);
//		glVertex3f(	sqaure_info[i].X_pos	,	-1.0f	,	sqaure_info[i].z_pos	);glColor3fv(rgb);
//		glVertex3f(	sqaure_info[i].x_pos	,	-1.0f	,	sqaure_info[i].z_pos	);glColor3fv(rgb);
//		glVertex3f(	sqaure_info[i].x_pos	,	-1.0f	,	sqaure_info[i].Z_pos	);glColor3fv(rgb);
//		glVertex3f(	sqaure_info[i].X_pos	,	-1.0f	,	sqaure_info[i].Z_pos	);
		}
	}
	glEnd();
	//glEnable(GL_LIGHTING);
}


