#include "particle_system.h"

void particle_system::caculate(int flow_grid_start, int total_frames, flow_grid *grid_pointer)
{
	vehicle temp;
	if ((int)particle_list.size()<1000)
	{
	
	

	//START POSITION OF VECTORS
	//initiate position
	float spawnX =grid_pointer->motion_vec[flow_grid_start].positionX;
	float spawnY =0.2;
	float spawnZ =grid_pointer->motion_vec[flow_grid_start].positionZ;
	//initiate partical velocity to that of the grid_start number.
	float velocityX=grid_pointer->motion_vec[flow_grid_start].directionX;
	float velocityY=grid_pointer->motion_vec[flow_grid_start].directionY;
	float velocityZ=grid_pointer->motion_vec[flow_grid_start].directionZ;


	//set our particles varibles
	
	temp.grid_ref   = flow_grid_start;
	temp.position.x = spawnX;
	temp.position.y = spawnY;
	temp.position.z = spawnZ;
	
	temp.velocity.x = velocityX;
	temp.velocity.y = velocityY;
	temp.velocity.z = velocityZ;
	temp.Max_Speed=0.03;
	//push vector
	temp.pushzdfg.x=0;
	temp.pushzdfg.y=0;
	temp.pushzdfg.z=0;
	particle_list.push_back(temp);
	}
	
	
	
	
	
	//LOOP THROUGH THE PARTICLES
	int reference;
	//create a iterator to allow us to destroy our particles
	vector<vehicle>::iterator theIterator=particle_list.begin();

	float attenuation=0.010;
	CVector3 flow_vec;
	int flow_vecs_nums[9];
	int size_of_system=(int)particle_list.size();
	for (int i=0; i<size_of_system; i++)
	{
	


	//1/(y- y2);
	reference = particle_list[i].grid_ref;
	
	
    //get the direction  of the flow vectors around this particles position
	particle_list[i].velocity.x = ((particle_list[i].velocity.x+0.0000001)*.95 + (grid_pointer->motion_vec[reference].directionX+0.0000001)*.05)+0.0000001;
	particle_list[i].velocity.z = ((particle_list[i].velocity.z+0.0000001)*.95 + (grid_pointer->motion_vec[reference].directionZ+0.0000001)*.05)+0.0000001;


		
	//create one vector * that by the max speed /acceleration of the particle
	particle_list[i].position.x = particle_list[i].position.x + ((particle_list[i].velocity.x*particle_list[i].Max_Speed)+ particle_list[i].pushzdfg.x)+0.0000001;
	particle_list[i].position.z = particle_list[i].position.z + ((particle_list[i].velocity.z*particle_list[i].Max_Speed)+ particle_list[i].pushzdfg.z)+0.0000001;

	particle_list[i].pushzdfg.x=0;
	particle_list[i].pushzdfg.z=0;
		
	
	
	//COLISIONS check to see if the particles are to close to each other
	
		
	
				//UPDATE GRID REFERENCE
				//does particle still exist in its current grid space
				if (particle_list[i].position.x> grid_pointer->motion_vec[reference].positionX+grid_pointer->step_sizeX)
				{particle_list[i].grid_ref=particle_list[i].grid_ref+grid_pointer->sizeZ;}
					

				if (particle_list[i].position.x< grid_pointer->motion_vec[reference].positionX-grid_pointer->step_sizeX)
				{particle_list[i].grid_ref=particle_list[i].grid_ref-grid_pointer->sizeZ;}
           
					
				if (particle_list[i].position.z> grid_pointer->motion_vec[reference].positionZ+grid_pointer->step_sizeZ)
				{particle_list[i].grid_ref++;}
				
				
				if (particle_list[i].position.z< grid_pointer->motion_vec[reference].positionZ-grid_pointer->step_sizeZ)
				{particle_list[i].grid_ref--;}
					
				
			
				//DELETE PARTICLES THAT HAVE LEFT THE GRID
				if (particle_list[i].position.z <grid_pointer->motion_vec[0].positionZ - grid_pointer->step_sizeZ)
				particle_list[i].grid_ref=0;
				
				if (particle_list[i].position.x <grid_pointer->motion_vec[0].positionX - grid_pointer->step_sizeX)
				particle_list[i].grid_ref=0;
				if (particle_list[i].position.z >grid_pointer->motion_vec[grid_pointer->grid_size-1].positionZ + grid_pointer->step_sizeZ)
				particle_list[i].grid_ref=0;
				if (particle_list[i].position.x >grid_pointer->motion_vec[grid_pointer->grid_size-1].positionX + grid_pointer->step_sizeX)
				particle_list[i].grid_ref=0;
				
				theIterator++;
		size_of_system=(int)particle_list.size();
		double hn;
		float difX;
		float difZ;
      /*  for (int p=0; p<size_of_system; p++)
		{
			if ( p!=i)
	
			{
			//cout<<"yes"<<endl;
				difX = particle_list[p].position.x - particle_list[i].position.x;
				difZ = particle_list[p].position.z - particle_list[i].position.z;
				//cout<<"difX:"<<difX<<endl;
				//cout<<"difZ:"<<difZ<<endl;
				hn=0;//(1/( abs((int)difX) + abs((int)difZ) +0.00001))* 0.000000004;
				//cout <<hn<<endl;
				particle_list[p].pushzdfg.x =particle_list[p].pushzdfg.x + ((difX+0.00001)*hn);
				particle_list[p].pushzdfg.z =particle_list[p].pushzdfg.z + ((difZ+0.00001)*hn);
			}

		}*/
	}
	

}

//RENDER OUR SYSTEM
void particle_system::render()
{
	int amount = (int)particle_list.size();
	glPointSize(8);
   	for (int i=0; i<amount; i++)
	{
		glBegin(GL_POINTS);
			glColor3f(1.0,1.0,1.0);
			glVertex3f(particle_list[i].position.x,particle_list[i].position.y,particle_list[i].position.z);			
		glEnd();

		glBegin(GL_LINES);
			glColor3f(0.5,0.5,0.5);
			glVertex3f(particle_list[i].position.x,particle_list[i].position.y,particle_list[i].position.z);
			glColor3f(1.0,1.0,1.0);
			glVertex3f( particle_list[i].position.x + particle_list[i].velocity.x , particle_list[i].position.y,
					    particle_list[i].position.z + particle_list[i].velocity.z);
		glEnd();
	}
	glColor3f(0.4,0.4,0.4);
}
// RENDER THEM as points or output their velocity
//do a simple loop